#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define AEC_FUNCTIONS
#include "AkelEdit.h"
#include "AkelDLL.h"


//Defines
#define STRID_INFO  1

//Functions prototypes
char* GetLangStringA(LANGID wLangID, int nStringID);
wchar_t* GetLangStringW(LANGID wLangID, int nStringID);
void InitCommon(PLUGINDATA *pd);

//Global variables
HWND hMainWnd;
HWND hWndEdit;
BOOL bOldWindows;
BOOL bAkelEdit;
LANGID wLangSystem;
BOOL bInitCommon=FALSE;


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(-1, -1, -1, -1);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="Stats";
}

//Plugin extern function
extern "C" void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  //Function doesn't support autoload
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=FALSE;
    return;
  }

  InitCommon(pd);

  //Calculate
  {
    AECHARRANGE crInit;
    AECHARRANGE crCount;
    AECHARINDEX ciWordStart;
    AECHARINDEX ciWordEnd;
    AECHARINDEX ciCount;
    AEINDEXSUBTRACT is;
    int nCharCount=0;
    int nCharLatin=0;
    int nCharNonLatin=0;
    int nCharSpaces=0;
    int nCharSurrogate=0;
    int nWordCount=0;
    int nLineCount=0;
    BOOL bFirst=TRUE;

    if (hWndEdit)
    {
      SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTSELCHAR, (LPARAM)&crInit.ciMin);
      SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTSELCHAR, (LPARAM)&crInit.ciMax);

      if (!AEC_IndexCompare(&crInit.ciMin, &crInit.ciMax))
      {
        SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&crInit.ciMin);
        SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&crInit.ciMax);

        //Line count
        nLineCount=(crInit.ciMax.nLine - crInit.ciMin.nLine) + 1;

        //Char count
        is.ciChar1=&crInit.ciMax;
        is.ciChar2=&crInit.ciMin;
        is.bColumnSel=FALSE;
        is.nNewLine=AELB_ASOUTPUT;
        nCharCount=SendMessage(hWndEdit, AEM_INDEXSUBTRACT, 0, (LPARAM)&is);

        //Word count
        ciCount=crInit.ciMin;

        while (1)
        {
          if (!SendMessage(hWndEdit, AEM_GETNEXTBREAK, AEWB_RIGHTWORDEND, (LPARAM)&ciCount))
            break;

          ++nWordCount;
        }

        //Symbols detalization
        for (ciCount=crInit.ciMin; AEC_IndexCompare(&ciCount, &crInit.ciMax) < 0; AEC_NextChar(&ciCount))
        {
          if (ciCount.nCharInLine < ciCount.lpLine->nLineLen)
          {
            if (AEC_IndexLen(&ciCount) == 1)
            {
              if (ciCount.lpLine->wpLine[ciCount.nCharInLine] <= 0x80)
              {
                if (ciCount.lpLine->wpLine[ciCount.nCharInLine] == L' ' ||
                    ciCount.lpLine->wpLine[ciCount.nCharInLine] == L'\t')
                {
                  ++nCharSpaces;
                }
                else ++nCharLatin;
              }
              else ++nCharNonLatin;
            }
            else ++nCharSurrogate;
          }
        }
      }
      else
      {
        //Line count
        nLineCount=(crInit.ciMax.nLine - crInit.ciMin.nLine) + 1;

        //Char count
        is.ciChar1=&crInit.ciMax;
        is.ciChar2=&crInit.ciMin;
        is.bColumnSel=SendMessage(hWndEdit, AEM_GETCOLUMNSEL, 0, 0);
        is.nNewLine=AELB_ASOUTPUT;
        nCharCount=SendMessage(hWndEdit, AEM_INDEXSUBTRACT, 0, (LPARAM)&is);

        //Word count
        if (is.bColumnSel)
        {
          crCount=crInit;

          while (AEC_IndexCompare(&crCount.ciMin, &crCount.ciMax) < 0)
          {
            ciWordEnd=crCount.ciMin;

            while (1)
            {
              if (!SendMessage(hWndEdit, AEM_GETNEXTBREAK, AEWB_RIGHTWORDEND, (LPARAM)&ciWordEnd))
                goto Symbols;

              if (ciWordEnd.nLine == crCount.ciMin.nLine && ciWordEnd.nCharInLine <= crCount.ciMin.lpLine->nSelEnd)
              {
                if (bFirst)
                {
                  bFirst=FALSE;
                  ciWordStart=ciWordEnd;

                  if (SendMessage(hWndEdit, AEM_GETPREVBREAK, AEWB_LEFTWORDSTART, (LPARAM)&ciWordStart))
                    if (AEC_IndexCompare(&crCount.ciMin, &ciWordStart) <= 0)
                      ++nWordCount;
                }
                else ++nWordCount;

                if (ciWordEnd.nCharInLine == crCount.ciMin.lpLine->nSelEnd)
                  break;
              }
              else break;
            }

            //Next line
            bFirst=TRUE;
            if (AEC_NextLine(&crCount.ciMin))
              crCount.ciMin.nCharInLine=crCount.ciMin.lpLine->nSelStart;
          }
        }
        else
        {
          crCount=crInit;

          while (1)
          {
            ciWordEnd=crCount.ciMin;

            if (!SendMessage(hWndEdit, AEM_GETNEXTBREAK, AEWB_RIGHTWORDEND, (LPARAM)&ciWordEnd))
              goto Symbols;

            if (AEC_IndexCompare(&ciWordEnd, &crCount.ciMax) <= 0)
            {
              if (bFirst)
              {
                bFirst=FALSE;
                ciWordStart=ciWordEnd;

                if (SendMessage(hWndEdit, AEM_GETPREVBREAK, AEWB_LEFTWORDSTART, (LPARAM)&ciWordStart))
                  if (AEC_IndexCompare(&crCount.ciMin, &ciWordStart) <= 0)
                    ++nWordCount;
              }
              else ++nWordCount;

              if (AEC_IndexCompare(&ciWordEnd, &crCount.ciMax) == 0)
                break;
            }
            else break;

            //Next word
            crCount.ciMin=ciWordEnd;
          }
        }

        //Symbols detalization
        Symbols:

        for (ciCount=crInit.ciMin; AEC_IndexCompare(&ciCount, &crInit.ciMax) < 0; AEC_NextChar(&ciCount))
        {
          if (ciCount.nCharInLine < ciCount.lpLine->nSelStart)
            ciCount.nCharInLine=ciCount.lpLine->nSelStart;

          if (ciCount.nCharInLine < ciCount.lpLine->nLineLen &&
              ciCount.nCharInLine < ciCount.lpLine->nSelEnd)
          {
            if (AEC_IndexLen(&ciCount) == 1)
            {
              if (ciCount.lpLine->wpLine[ciCount.nCharInLine] <= 0x80)
              {
                if (ciCount.lpLine->wpLine[ciCount.nCharInLine] == L' ' ||
                    ciCount.lpLine->wpLine[ciCount.nCharInLine] == L'\t')
                {
                  ++nCharSpaces;
                }
                else ++nCharLatin;
              }
              else ++nCharNonLatin;
            }
            else ++nCharSurrogate;
          }
          else AEC_NextLine(&ciCount);
        }
      }
    }

    //Show result
    if (bOldWindows)
    {
      char szMsg[MAX_PATH];

      wsprintfA(szMsg, GetLangStringA(wLangSystem, STRID_INFO), nCharCount, nWordCount, nLineCount);
      MessageBoxA(hMainWnd, szMsg, "Stats plugin", MB_OK|MB_ICONINFORMATION);
    }
    else
    {
      wchar_t wszMsg[MAX_PATH];

      wsprintfW(wszMsg, GetLangStringW(wLangSystem, STRID_INFO), nCharCount, nCharLatin, nCharNonLatin, nCharSpaces, nCharSurrogate, nWordCount, nLineCount);
      MessageBoxW(hMainWnd, wszMsg, L"Stats plugin", MB_OK|MB_ICONINFORMATION);
    }
  }
}

char* GetLangStringA(LANGID wLangID, int nStringID)
{
  static char szStringBuf[MAX_PATH];

  WideCharToMultiByte(CP_ACP, 0, GetLangStringW(wLangID, nStringID), -1, szStringBuf, MAX_PATH, NULL, NULL);
  return szStringBuf;
}

wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_INFO)
      return L"\x0421\x0438\x043C\x0432\x043E\x043B\x044B=%d\n    \x041B\x0430\x0442\x0438\x043D\x0441\x043A\x0438\x0435=%d\n    \x041D\x0435\x043B\x0430\x0442\x0438\x043D\x0441\x043A\x0438\x0435=%d\n    \x041F\x0440\x043E\x0431\x0435\x043B\x044B=%d\n    \x0421\x0443\x0440\x0440\x043E\x0433\x0430\x0442\x044B=%d\n\x0421\x043B\x043E\x0432\x0430=%d\n\x0421\x0442\x0440\x043E\x043A\x0438=%d\n";
  }
  else
  {
    if (nStringID == STRID_INFO)
      return L"Chars=%d\n    Latin=%d\n    NonLatin=%d\n    Spaces=%d\n    Surrogates=%d\nWords=%d\nLines=%d\n";
  }
  return L"";
}

void InitCommon(PLUGINDATA *pd)
{
  bInitCommon=TRUE;
  hMainWnd=pd->hMainWnd;
  hWndEdit=pd->hWndEdit;
  bOldWindows=pd->bOldWindows;
  bAkelEdit=pd->bAkelEdit;
  wLangSystem=PRIMARYLANGID(pd->wLangSystem);
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
